# napari-ome-zarr-navigator <img align="right" height="150" src="https://raw.githubusercontent.com/fractal-napari-plugins-collection/napari-ome-zarr-navigator/master/docs/images/navigator_logo.png">

[![License BSD-3](https://img.shields.io/pypi/l/napari-ome-zarr-navigator.svg?color=green)](https://github.com/fractal-analytics-platform/napari-ome-zarr-navigator/raw/main/LICENSE)
[![PyPI](https://img.shields.io/pypi/v/napari-ome-zarr-navigator.svg?color=green)](https://pypi.org/project/napari-ome-zarr-navigator)
[![Python Version](https://img.shields.io/pypi/pyversions/napari-ome-zarr-navigator.svg?color=green)](https://python.org)
[![tests](https://github.com/fractal-analytics-platform/napari-ome-zarr-navigator/workflows/tests/badge.svg)](https://github.com/fractal-analytics-platform/napari-ome-zarr-navigator/actions)
[![codecov](https://codecov.io/gh/fractal-analytics-platform/napari-ome-zarr-navigator/branch/main/graph/badge.svg)](https://codecov.io/gh/fractal-analytics-platform/napari-ome-zarr-navigator)
[![napari hub](https://img.shields.io/endpoint?url=https://api.napari-hub.org/shields/napari-ome-zarr-navigator)](https://napari-hub.org/plugins/napari-ome-zarr-navigator)

A plugin to browse OME-Zarr plates by conditions and load images, labels and features from ROIs


## Usage

The ImageBrowser recognizes OME-Zarr plates that were loaded via [napari-ome-zarr](https://github.com/ome/napari-ome-zarr) and allows the selection of wells in the multiwell plate.

<img width="1624" alt="navigator_1" src="https://github.com/user-attachments/assets/86c0c0d5-df4c-4579-8719-c36efe67485c">

The ImageBrowser allows to zoom to a given well ("Go to well") & puts a white bounding box around the selected well.

<img width="1624" alt="navigator_2" src="https://github.com/user-attachments/assets/13ead72a-de0e-4b03-8051-b9759af4a131">

Using prototype `condition tables` (to be defined better, see sample data provided by the plugin orthe example in the test data below), the ImageBrowser allows for selecting subsets of the well list based on conditions defined in the `condition table`. The [operetta-compose Fractal task package](https://github.com/leukemia-kispi/operetta-compose) provides a task to create such condition tables.


<img width="1624" alt="navigator_3" src="https://github.com/user-attachments/assets/f8cb9311-49ef-43fd-9358-4193ffb58877">

The ROI loader (formerly [available separately as a napari plugin](https://github.com/jluethi/napari-ome-zarr-roi-loader)) can be used standalone or integrated with the ImageBrowser. If a well is selected from the ImageBrowser, all the images in that well can be loaded via the ROI loader.
This supports:
- Loading images from different multiplexing acquisitions
- Loading any ROI based on [Fractal ROI tables](https://fractal-analytics-platform.github.io/fractal-tasks-core/tables/#roi-tables)
- Loading label images
- Loading feature measurements (based on [Fractal feature tables](https://fractal-analytics-platform.github.io/fractal-tasks-core/tables/#feature-tables) in the AnnData format)

This approach of loading label images and feature data has been optimized for and tested with the [napari feature classifier](https://github.com/fractal-napari-plugins-collection/napari-feature-classifier).

<img width="1624" alt="navigator_4" src="https://github.com/user-attachments/assets/0548c8f1-23c3-4c55-9388-c818bb94bbc3">

This plugin is meant to work well for OME-Zarr files generated by [Fractal](https://fractal-analytics-platform.github.io/).

----------------------------------


## Test data

Test data is available at https://zenodo.org/records/11262587


## Installation

You can install `napari-ome-zarr-navigator` via [pip]:

    pip install napari-ome-zarr-navigator



To install latest development version :

    pip install git+https://github.com/fractal-analytics-platform/napari-ome-zarr-navigator.git


## Contributing

Contributions are very welcome. Tests can be run with [tox], please ensure
the coverage at least stays the same before you submit a pull request.

## License

Distributed under the terms of the [BSD-3] license,
"napari-ome-zarr-navigator" is free and open source software

## Issues

If you encounter any problems, please [file an issue] along with a detailed description.

This [napari] plugin was generated with [Cookiecutter] using [@napari]'s [cookiecutter-napari-plugin] template.

[napari]: https://github.com/napari/napari
[Cookiecutter]: https://github.com/audreyr/cookiecutter
[@napari]: https://github.com/napari
[MIT]: http://opensource.org/licenses/MIT
[BSD-3]: http://opensource.org/licenses/BSD-3-Clause
[GNU GPL v3.0]: http://www.gnu.org/licenses/gpl-3.0.txt
[GNU LGPL v3.0]: http://www.gnu.org/licenses/lgpl-3.0.txt
[Apache Software License 2.0]: http://www.apache.org/licenses/LICENSE-2.0
[Mozilla Public License 2.0]: https://www.mozilla.org/media/MPL/2.0/index.txt
[cookiecutter-napari-plugin]: https://github.com/napari/cookiecutter-napari-plugin

[file an issue]: https://github.com/fractal-analytics-platform/napari-ome-zarr-navigator/issues

[napari]: https://github.com/napari/napari
[tox]: https://tox.readthedocs.io/en/latest/
[pip]: https://pypi.org/project/pip/
[PyPI]: https://pypi.org/
